public class Contenitore {
// Attributi
 private static final int MAX_NUM_DISCHI=15;
 private Programma dischi[];
 public Contenitore() {
  dischi=new Programma[MAX_NUM_DISCHI];
 }
public Contenitore(Contenitore contenitore) {
 int posizione;
 dischi=new Programma[MAX_NUM_DISCHI];
 for(posizione=0; posizione<MAX_NUM_DISCHI; posizione++) {
  if (contenitore.getProgramma(posizione)!=null)
   dischi[posizione]=new Programma(contenitore.getProgramma(posizione));
 }
}
// Metodi
 public int setProgramma(Programma Programma, int posizione) {
  try {
// inserimento copia di Programma in posizione
   if (dischi[posizione]!=null)
    return -2; // posizione occupata
   dischi[posizione]=new Programma(Programma);
   return posizione; // restituisce la posizione di inserimento
  }
  catch (ArrayIndexOutOfBoundsException exception) {
   return -1; // posizione non valida
  }
 }
 public Programma getProgramma(int posizione) {
  try {
  // restituisce una copia del Programma in posizione
   return new Programma(dischi[posizione]);
  }
 catch (ArrayIndexOutOfBoundsException exception) {
  return null; // posizione non valida: nessun Programma restituito
 }
  catch (NullPointerException exception) {
   return null; // posizione vuota: nessun Programma restituito
  }
 }
public int killProgramma(int posizione) {
 try {
  dischi[posizione]=null; // rimozione Programma in posizione
  return posizione; // restituisce la posizione liberata
 }
 catch (ArrayIndexOutOfBoundsException exception) {
  return -1; // posizione non valida
 }
}
public int getNumMaxdischi() {
 return MAX_NUM_DISCHI;
}
public int getN() {
 int posizione, n=0;
 for (posizione=0; posizione<MAX_NUM_DISCHI; posizione++)
  if (dischi[posizione]!=null)
   n++;
  return n;
 }

public int cercaProgrammaPerDenominazione(String denominazione) {
 int posizione;
 for (posizione=0; posizione<MAX_NUM_DISCHI; posizione++)
  if (dischi[posizione].getDenominazione().equals(denominazione))
   return posizione;
  return -1;
 }

public String toString(){
   String elenco="";
   int posizione;
 for (posizione=0; posizione<MAX_NUM_DISCHI; posizione++)
  if (dischi[posizione]!=null) elenco=elenco+dischi[posizione].getDenominazione();
 return elenco;  
}


public int confrontaContenitore(Contenitore c){
  int posizione1,posizione2,presenti=0;
  for (posizione1=0; posizione1<MAX_NUM_DISCHI; posizione1++)
      if (dischi[posizione1]!=null){
       for (posizione2=0; posizione2<MAX_NUM_DISCHI; posizione2++)
           if (c.getProgramma(posizione2)!=null){
              if (dischi[posizione1].equals(c.getProgramma(posizione2))){
                presenti++;
              }
           }
      } 
 return presenti;  
}


 

 public static void main (String[] args) throws java.io.IOException {
   Contenitore c1 = new Contenitore();
   Programma p1=new Programma("OpenOffice","Apache Software Foundation","3.3.0","Linux",2010);
   Programma p2=new Programma("MsOffice","Microsoft","2010","Windows",2010);
   Programma p3=new Programma(p1);
   Programma p4=new Programma("Lotus Suite","Lotus","v1.2","Windows",1998);
   
   System.out.println("Numero dischi contenitore c1: "+c1.getN());
   // inserimento dischi
   c1.setProgramma(p3, 0);
   c1.setProgramma(p2, 2);
   c1.setProgramma(p1, 3);
   System.out.println("Numero dischi contenitore c1: "+c1.getN());
   // visualizzazione elenco dischi
   for ( int posizione=0; posizione<c1.getNumMaxdischi(); posizione++) {
     Programma p = c1.getProgramma(posizione);
     if (p != null)
       System.out.println( "posizione: "+posizione+" -> "+p.toString());
   }
   Contenitore c2 = new Contenitore();
   c2.setProgramma(p4,4);
   c2.setProgramma(p2, 5);
   System.out.println("Il contenitore c2 contiene " +c2.confrontaContenitore(c1)+ " elemento/i presenti in c1");
   
   }
 }