import java.io.*;
public class Mensola {
// Attributi
 private static final int MAX_NUM_VOLUMI=15;
 private Libro volumi[];
 public Mensola() {
  volumi=new Libro[MAX_NUM_VOLUMI];
 }
public Mensola(Mensola mensola) {
 int posizione;
 volumi=new Libro[MAX_NUM_VOLUMI];
 for(posizione=0; posizione<MAX_NUM_VOLUMI; posizione++) {
  if (mensola.getVolume(posizione)!=null)
   volumi[posizione]=new Libro(mensola.getVolume(posizione));
 }
}
// Metodi
 public int setVolume(Libro libro, int posizione) {
  try {
// inserimento copia di libro in posizione
   if (volumi[posizione]!=null)
    return -2; // posizione occupata
   volumi[posizione]=new Libro(libro);
   return posizione; // restituisce la posizione di inserimento
  }
  catch (ArrayIndexOutOfBoundsException exception) {
   return -1; // posizione non valida
  }
 }
 public Libro getVolume(int posizione) {
  try {
  // restituisce una copia del libro in posizione
   return new Libro(volumi[posizione]);
  }
 catch (ArrayIndexOutOfBoundsException exception) {
  return null; // posizione non valida: nessun libro restituito
 }
  catch (NullPointerException exception) {
   return null; // posizione vuota: nessun libro restituito
  }
 }
public int rimuoviVolume(int posizione) {
 try {
  volumi[posizione]=null; // rimozione libro in posizione
  return posizione; // restituisce la posizione liberata
 }
 catch (ArrayIndexOutOfBoundsException exception) {
  return -1; // posizione non valida
 }
}
public int getNumMaxVolumi() {
 return MAX_NUM_VOLUMI;
}
public int getNumVolumi() {
 int posizione, n=0;
 for (posizione=0; posizione<MAX_NUM_VOLUMI; posizione++)
  if (volumi[posizione]!=null)
   n++;
  return n;
 }

 public void salvaMensola() throws java.io.IOException {
  ObjectOutputStream stream =
  new ObjectOutputStream(new FileOutputStream("volumi.bin"));
  stream.writeObject(this.volumi);
  stream.close();
 }

public void caricaMensola() throws java.io.IOException {
 ObjectInputStream stream = new ObjectInputStream(new FileInputStream("volumi.bin"));
 try {
     this.volumi = (Libro[])stream.readObject();
 }
 catch (ClassNotFoundException exception) {
 }
  stream.close();
 }

 public static void main (String[] args) throws java.io.IOException {
   Mensola mensola = new Mensola();
   Libro l1 = new Libro("Pinocchio", "C. Collodi", 150);
   Libro l2 = new Libro("Pollicino", "C. Perrault", 80);
   Libro l3 = new Libro( "La bella addormentata nel bosco", "C. Perrault", 50);
   System.out.println("Numero volumi: "+mensola.getNumVolumi());
   // inserimento volumi
   mensola.setVolume(l1, 0);
   mensola.setVolume(l2, 2);
   mensola.setVolume(l3, 10);
   System.out.println("Numero volumi: "+mensola.getNumVolumi());
   // visualizzazione elenco volumi
   for ( int posizione=0; posizione<mensola.getNumMaxVolumi(); posizione++) {
     Libro libro = mensola.getVolume(posizione);
     if (libro != null)
       System.out.println( "posizione: "+posizione+" -> "+libro.getTitolo()+" "+libro.prezzo()+"");
   }
   // salvataggio volumi su file
   mensola.salvaMensola();
   // creazione nuova mensola vuota
   mensola = new Mensola();
   System.out.println("Numero volumi: "+mensola.getNumVolumi());
   // caricamento volumi da file
   mensola.caricaMensola();
   System.out.println("Numero volumi: "+mensola.getNumVolumi());
   // visualizzazione elenco volumi
   for ( int posizione=0; posizione<mensola.getNumMaxVolumi();posizione++) {
     Libro libro = mensola.getVolume(posizione);
     if (libro != null)
      System.out.println( "posizione: "+posizione+" -> "+libro.getTitolo()+" "+libro.prezzo()+"");
   }
 }
}