import java.io.*;
public class ParcoComputer {
    

// Attributi
 private static final int MAX_NUM_COMPUTER=100;
 private int codice=-1;
 private Computer catalogo[];
 public ParcoComputer() {
  catalogo=new Computer[MAX_NUM_COMPUTER];
 }

// Metodi
 public int setComputer(Computer computer) {
  try { codice++;
// inserimento copia di Computer in posizione relativa al codice
   catalogo[codice]=new Computer(computer);
   return codice; // restituisce la posizione di inserimento
  }
  catch (ArrayIndexOutOfBoundsException exception) {
   return -1; // posizione non valida
  }
 }
 
 public Computer getComputer(int codice) {
  try {
  // restituisce una copia del Computer in posizione
   return new Computer(catalogo[codice]);
  }
 catch (ArrayIndexOutOfBoundsException exception) {
  return null; // posizione non valida: nessun Computer restituito
 }
  catch (NullPointerException exception) {
   return null; // posizione vuota: nessun Computer restituito
  }
 }
 
public int rimuoviComputer(int codice) {
 try {
  catalogo[codice]=null; // rimozione Computer in posizione
  return codice; // restituisce la posizione liberata
 }
 catch (ArrayIndexOutOfBoundsException exception) {
  return -1; // posizione non valida
 }
}

public int getNumMaxComputer() {
 return MAX_NUM_COMPUTER;
}
public int getNumComputer() {
 int posizione, n=0;
 for (posizione=0; posizione<MAX_NUM_COMPUTER; posizione++)
  if (catalogo[posizione]!=null)
   n++;
  return n;
 }

public void salvaParcoComputer() throws java.io.IOException {
  ObjectOutputStream stream =new ObjectOutputStream(new FileOutputStream("catalogo.bin"));
  stream.writeObject(this.catalogo);
  stream.close();
 }

public void caricaParcoComputer() throws java.io.IOException {
 ObjectInputStream stream = new ObjectInputStream(new FileInputStream("catalogo.bin"));
 try {
     this.catalogo = (Computer[])stream.readObject();
 }
 catch (ClassNotFoundException exception) {
 }
  stream.close();
 }

public String[] computerCaratteristiche(float velocita,int ram, int disco){
 int i,j=0;
 String elenco[]=new String[MAX_NUM_COMPUTER];
 for (i=0;i<MAX_NUM_COMPUTER;i++)
  if (catalogo[i]!=null)
      if ((catalogo[i].getVelocita()>=velocita) &&(catalogo[i].getRam()>=ram)&&(catalogo[i].getDisco()>=disco)){
        elenco[j]="Codice: "+i+" "+catalogo[i].toString();
        j++;
      }  
 return elenco;
}
        

 public static void main (String[] args) throws java.io.IOException {
   int i;
   String elenco[];
   ParcoComputer parco1 = new ParcoComputer();
   Computer v1 = new Computer("Asus","AX210",2.5F,4,250,15,2010);
   Computer v2 = new Computer("Asus","AX210",2.5F,4,250,15,2010);
   Computer v3 = new Computer("Acer","Aspire",1.8F,2,150,16,2008);
   Computer v4 = new Computer("HP","EF310",2.0F,2,180,14,2009);
   Computer v5 = new Computer("Acer","BY110",2.0F,2,180,14,2009);
   // inserimento catalogo
   parco1.setComputer(v1);
   parco1.setComputer(v2);
   parco1.setComputer(v3);
   parco1.setComputer(v4);
   System.out.println("\nNumero computer parco computer 1: "+parco1.getNumComputer());
   // visualizzazione elenco catalogo
   for ( int posizione=0; posizione<parco1.getNumMaxComputer(); posizione++) {
     Computer Computer = parco1.getComputer(posizione);
     if (Computer != null)
       System.out.println( "Codice: "+posizione+" -> "+Computer.toString());
   }
   
   System.out.println("\nCatalogo parco computer 1 con velocit CPU>=2GHz,Ram>=2Gb,Disco>=200 Gb ");
   elenco=parco1.computerCaratteristiche(2.0F,2, 200);
   for(i=0;i<MAX_NUM_COMPUTER;i++){
       if(elenco[i]==null) break;
       System.out.println(elenco[i]);
   }
   // salvataggio catalogo su file
   parco1.salvaParcoComputer();
   // creazione nuova ParcoComputer vuota
   ParcoComputer parco2 = new ParcoComputer();
   System.out.println("\nNumero computer parco computer 2: "+parco2.getNumComputer());
   // caricamento catalogo da file
   System.out.println("\nCaricamento da file dati parco computer 2: ");
   parco2.caricaParcoComputer();
   System.out.println("\nNumero computer parco computer 2: "+parco2.getNumComputer());
   //elimina computer per targa
   if (parco2.rimuoviComputer(2)>=0)
    System.out.println("\nComputer con codice 2 eliminato ");
   else
    System.out.println("\nImpossibile eliminare computer con codice 2 (inesistente) ");   
   // visualizzazione elenco catalogo
   System.out.println("\nElenco computer rimanenti parco computer 2");
   for ( int posizione=0; posizione<parco2.getNumMaxComputer();posizione++) {
     Computer v6 = parco2.getComputer(posizione);
     if (v6 != null)
      System.out.println( "Posizione: "+posizione+" -> "+v6.toString()); 
   } 
 }
}