public class Polyline {
    private Vettore[] polyline;
    int N; // Vettores number

    public Polyline(int dim) {
        polyline = new Vettore[dim];

        N = 0;
        for (int i=0; i<dim; i++)
           polyline[i] = new Vettore();
    }
    
    public Polyline(Polyline p) {
        polyline = new Vettore[p.getVettoresNumber()];

        N = p.getVettoresNumber();
        for (int i=0; i<N; i++)
           polyline[i] = new Vettore(p.getVettore(i+1));
    }

    public int getVettoresNumber() {
        return N;
    }

    public void addVettore(double X0, double Y0, double X1, double Y1) {
        Vettore tmp = new Vettore(X0, Y0, X1, Y1);

        if (N == polyline.length)
          return;

        if (N == 0) {
          polyline[N] = tmp;
          N++;
        }
        if (N > 0) {
            if (polyline[N-1].getX1() == X0 && polyline[N-1].getY1() == Y0) {
              polyline[N] = tmp;
              N++;
            }
        }

        return;
    }

    public void addVettore(Vettore v) {
        Vettore tmp = new Vettore(v);

        if (N == 0) {
          polyline[N] = tmp;
          N++;
        }
        if (N > 0) {
            if (polyline[N-1].getX1() == v.getX0() && polyline[N-1].getY1() == v.getY0()) {
              polyline[N] = tmp;
              N++;
            }
        }

        return;
    }

    public Vettore getVettore(int i) {
        Vettore tmp = null;

        if (i>=1 && i<=N) {
            tmp = new Vettore(polyline[i-1]);
        }

        return tmp;
    }

    public boolean equals (Polyline p) {
        if (N != p.getVettoresNumber())
            return false;

        for (int i=0; i<N; i++)
            if (!polyline[i].equals(p.getVettore(i)))
                return false;

        return true;
    }

    public String toString() {
        String s = "[";

        for (int i=0; i<N-1; i++)
           s = s + polyline[i].toString() + ",";
        s = s + polyline[N-1].toString() + "]";

        return s;
    }

    public double length() {
        double l = 0;

        for (int i=0; i<N; i++)
            l += polyline[i].length();

        return l;
    }

    public boolean simple() {
        for (int i=0; i<N-1; i++)
            for (int j=i+1; j<N; j++)
                if (polyline[i].interseca(polyline[j]))
                    return false;
        return true;
    }
     public static void main(String[] args) {
        Vettore v1, v2, v3,v4;

        v1 = new Vettore(0,0,1,1);
        System.out.println(v1);
        System.out.println(v1.length());

        v2 = new Vettore(1,1,1,2);
        System.out.println(v2);
        System.out.println(v2.length());

        v3 = new Vettore(1,2,0,-1);
        System.out.println(v3);
        System.out.println(v3.length());
        
        v4 = new Vettore(0,-1,1,-1);
        System.out.println(v4);
        System.out.println(v4.length());
        Polyline p=new Polyline(4);
        p.addVettore(v1);
        p.addVettore(v2);
        p.addVettore(v3);
        p.addVettore(v4);
        System.out.println("Poligonale: " +p.toString());
        System.out.println("Lunghezza poligonale: "+ p.length());
        if (p.simple())
            System.out.println ("Poligonale non incrociata");
        else
            System.out.println ("Poligonale incrociata");
    }
}