public class PortaCD {

// Attributi
 private int max_num_cd;
 private CD dischi[];
 public PortaCD(int N) {
  max_num_cd=N;   
  dischi=new CD[max_num_cd];
 }

// Metodi
 public int setCD(CD CD, int posizione) {
  try {
// inserimento copia di CD in posizione
   if (dischi[posizione]!=null)
    return -2; // posizione occupata
   dischi[posizione]=new CD(CD);
   return posizione; // restituisce la posizione di inserimento
  }
  catch (ArrayIndexOutOfBoundsException exception) {
   return -1; // posizione non valida
  }
 }
 public CD getCD(int posizione) {
  try {
  // restituisce una copia del CD in posizione
   return new CD(dischi[posizione]);
  }
 catch (ArrayIndexOutOfBoundsException exception) {
  return null; // posizione non valida: nessun CD restituito
 }
  catch (NullPointerException exception) {
   return null; // posizione vuota: nessun CD restituito
  }
 }
public int killCD(int posizione) {
 try {
  dischi[posizione]=null; // rimozione CD in posizione
  return posizione; // restituisce la posizione liberata
 }
 catch (ArrayIndexOutOfBoundsException exception) {
  return -1; // posizione non valida
 }
}
public int getNumMaxdischi() {
 return max_num_cd;
}
public int getN() {
 int posizione, n=0;
 for (posizione=0; posizione<max_num_cd; posizione++)
  if (dischi[posizione]!=null)
   n++;
  return n;
 }

public int cercaCDPerTitolo(String Titolo) {
 int posizione;
 for (posizione=0; posizione<max_num_cd; posizione++)
  if (dischi[posizione].getTitolo().equals(Titolo))
   return posizione;
  return -1;
 }

public String toString(){
   String elenco="";
   int posizione;
 for (posizione=0; posizione<max_num_cd; posizione++)
  if (dischi[posizione]!=null) elenco=elenco+dischi[posizione].getTitolo();
 return elenco;  
}


public int confrontaCollezione(PortaCD c){
  int posizione1,posizione2,presenti=0;
  for (posizione1=0; posizione1<max_num_cd; posizione1++)
      if (dischi[posizione1]!=null){
       for (posizione2=0; posizione2<max_num_cd; posizione2++)
           if (c.getCD(posizione2)!=null){
               //System.out.println(dischi[posizione1].toString());
               //System.out.println(c.getCD(posizione2).toString());
              // System.out.println("");
              if (dischi[posizione1].equals(c.getCD(posizione2))){
                presenti++;
              }
           }
      } 
 return presenti;  
}


 

 public static void main (String[] args) throws java.io.IOException {
   PortaCD c1 = new PortaCD(10);
   CD cd1=new CD("Burattino senza fili","E.Bennato",8,40);
   CD cd2=new CD("Bufalo Bill","F.De Gregori",10,45);
   
   System.out.println("Numero dischi PortaCD c1: "+c1.getN());
   // inserimento dischi
   c1.setCD(cd1, 0);
   c1.setCD(cd2, 2);
   
   System.out.println("Numero dischi PortaCD c1: "+c1.getN());
   // visualizzazione elenco dischi
   for ( int posizione=0; posizione<c1.getNumMaxdischi(); posizione++) {
     CD p = c1.getCD(posizione);
     if (p != null)
       System.out.println( "posizione: "+posizione+" -> "+p.toString());
   }
   PortaCD c2 = new PortaCD(12);
   c2.setCD(cd1,4);
   c2.setCD(cd2, 5);
   System.out.println("Il PortaCD c2 contiene " +c2.confrontaCollezione(c1)+ " elemento/i presenti in c1");
   
   }
 }