public class Programma {
    private String denominazione;
    private String produttore;
    private String versione;
    private String sistema_operativo;
    private int anno;

    public Programma(String denominazione, String produttore, String versione, String sistema_operativo, int anno){
        this.denominazione=denominazione;
        this.produttore=produttore;
        this.versione=versione;
        this.sistema_operativo=sistema_operativo;
        this.anno=anno;
    }
    
    public Programma(Programma p){
        this.denominazione=p.getDenominazione();
        this.produttore=p.getProduttore();
        this.versione=p.getVersione();
        this.sistema_operativo=p.getSistema_operativo();
        this.anno=p.getAnno();
    }
    public int getAnno() {
        return anno;
    }

    public void setAnno(int anno) {
        this.anno = anno;
    }

    public String getDenominazione() {
        return denominazione;
    }

    public void setDenominazione(String denominazione) {
        this.denominazione = denominazione;
    }

    public String getProduttore() {
        return produttore;
    }

    public void setProduttore(String produttore) {
        this.produttore = produttore;
    }

    public String getSistema_operativo() {
        return sistema_operativo;
    }

    public void setSistema_operativo(String sistema_operativo) {
        this.sistema_operativo = sistema_operativo;
    }

    public String getVersione() {
        return versione;
    }

    public void setVersione(String versione) {
        this.versione = versione;
    }
    
    public String toString(){
        return "Programma: "+denominazione+ " Produttore: "+produttore+" Versione: "+ versione+
                " S.O.: "+sistema_operativo+" Anno: "+ anno;
    }
    
    public boolean compareAnno(Programma p){
        return (anno==p.getAnno());
    }
    
    public boolean equals(Programma p){
        return ((anno==p.getAnno())&&(denominazione.equals(p.getDenominazione())) && (produttore.equals(p.getProduttore()))&&
                (versione.equals(p.getVersione())) && (sistema_operativo.equals(p.getSistema_operativo()))) ;
    }
    
     public static void main(String[] args) {
        Programma p1=new Programma("OpenOffice","Apache Software Foundation","3.3.0","Linux",2010);
        Programma p2=new Programma("MsOffice","Microsoft","2010","Windows",2010);
        Programma p3=new Programma(p1);
        System.out.println(p1);
        System.out.println(p2);
        System.out.println(p3);
        if (p1.compareAnno(p2))
            System.out.println("I programmi p1 e p2 sono stati rilasciati nello stesso anno");
    }

}