public class Scaffale {
// Attributi
  private static final int NUM_RIPIANI=5;
  private Mensola ripiani[];
// Costruttori
public Scaffale() {
  int ripiano;
  ripiani=new Mensola[NUM_RIPIANI];
  for (ripiano=0; ripiano<NUM_RIPIANI; ripiano++) {
    ripiani[ripiano]=new Mensola();
  }
 }
public Scaffale(Scaffale scaffale) {
  int ripiano, posizione;
  Libro libro;
  ripiani=new Mensola[NUM_RIPIANI];
  for (ripiano=0; ripiano<NUM_RIPIANI; ripiano++) {
   ripiani[ripiano]=new Mensola();
   for ( posizione=0; posizione<ripiani[ripiano].getNumMaxVolumi(); ripiano++) {
    libro=scaffale.getLibro(ripiano, posizione);
    if (libro!=null)
     ripiani[ripiano].setVolume(libro, posizione);
   }
  }
 }
// Metodi
 public Libro getLibro(int ripiano, int posizione) {
  if ((ripiano<0)||(ripiano>=NUM_RIPIANI))
   return null; // ripiano non valido
  return ripiani[ripiano].getVolume(posizione);
 }
 public int setLibro(Libro libro, int ripiano, int posizione) {
  if ((ripiano<0)||(ripiano>=NUM_RIPIANI))
    return -1; // ripiano non valido
  if (ripiani[ripiano].setVolume(libro, posizione)<0)
    return -2; // posizione nel ripiano non valida o non vuota
  return 1; // inserimento effettuato
 }
 public int rimuoviLibro(int ripiano, int posizione) {
  if ((ripiano<0)||(ripiano>=NUM_RIPIANI))
    return -1; // ripiano non valido
   if (ripiani[ripiano].rimuoviVolume(posizione)<0)
    return -2; // posizione nel ripiano non valida o vuota
   return 1; // eliminazione effettuata
 }
 public int getNumRipiani() {
   return NUM_RIPIANI;
 }
 public int getNumMaxLibri() {
   int ripiano, n=0;
   for (ripiano=0; ripiano<NUM_RIPIANI; ripiano++) {
    n += ripiani[ripiano].getNumMaxVolumi();
   }
   return n;
}
 public int getNumLibri() {
  int ripiano, n=0;
  for (ripiano=0; ripiano<NUM_RIPIANI; ripiano++) {
   n += ripiani[ripiano].getNumVolumi();
  }
  return n;
 }
 public int getNumLibri(int ripiano) {
  if ((ripiano<0)||(ripiano>=NUM_RIPIANI))
   return -1; // ripiano non valido
  return ripiani[ripiano].getNumVolumi();
 }


public static void main (String[] args){
  Scaffale scaffale = new Scaffale();
  Libro libro;
  // creazione di tre oggetti di tipo Libro
  Libro l1=new Libro("Pinocchio", "C. Collodi", 150);
  Libro l2=new Libro("Pollicino", "C. Perrault", 80);
  Libro l3=new Libro( "La bella addormentata nel bosco", "C. Perrault", 50);
  // inserimento mensola #0
  scaffale.setLibro(l1, 0, 10);
  scaffale.setLibro(l2, 0, 0);
  // test inserimento mensola #1
  libro=new Libro("Cappuccetto Rosso", "F.lli Grimm", 150);
  scaffale.setLibro(libro, 1, 1);
  //test errori inserimento
  if (scaffale.setLibro(l3, 10, 0) == -1)
   System.out.println("mensola non valida");
  if (scaffale.setLibro(l3, 0, 20) == -2)
   System.out.println("posizione non valida o non libera");
  if (scaffale.setLibro(l3, 0, 10) == -2)
   System.out.println("posizione non valida o non libera");
   // inserimento mensola #1
   scaffale.setLibro(l3, 1, 0);
   // visualizzazione contenuto mensole
  for (int ripiano=0; ripiano<scaffale.getNumRipiani(); ripiano++) {
   for ( int posizione=0; posizione<scaffale.getNumLibri(ripiano);posizione++) {
     libro = scaffale.getLibro(ripiano, posizione);
     if (libro!=null)
     System.out.println("ripiano: "+ripiano+" posizione: "+posizione+" -> "+libro.getTitolo()+" "+libro.prezzo()+"");
   }
  }
// modifica titolo e autore libro estratto da scaffale
  libro=scaffale.getLibro(0,0);
  if (libro!=null) {
   libro.setTitolo("Sussi e Biribissi");
   libro.setAutore("Collodi nipote");
  }
// visualizzazione contenuto mensole
  for (int ripiano=0; ripiano<scaffale.getNumRipiani(); ripiano++) {
   for ( int posizione=0; posizione<scaffale.getNumLibri(ripiano);posizione++) {
    libro = scaffale.getLibro(ripiano, posizione);
    if (libro!=null)
     System.out.println("ripiano: "+ripiano+" posizione: "+posizione+" -> "+libro.getTitolo()+" "+libro.prezzo()+"");
   }
  }
 }
}