public class Vettore {

    private double X0;
    private double Y0;
    private double X1;
    private double Y1;

    public Vettore() {
        this.X0 = 0;
        this.Y0 = 0;
        this.X1 = 0;
        this.Y1 = 0;
    }

    public Vettore(double X0, double Y0, double X1, double Y1) {
        this.X0 = X0;
        this.Y0 = Y0;
        this.X1 = X1;
        this.Y1 = Y1;
    }

    public Vettore(Vettore v) {
        this.X0 = v.getX0();
        this.Y0 = v.getY0();
        this.X1 = v.getX1();
        this.Y1 = v.getY1();

    }


    public double getX0() {
        return X0;
    }

    public void setX0(double X0) {
        this.X0 = X0;
    }

    public double getX1() {
        return X1;
    }

    public void setX1(double X1) {
        this.X1 = X1;
    }

    public double getY0() {
        return Y0;
    }

    public void setY0(double Y0) {
        this.Y0 = Y0;
    }

    public double getY1() {
        return Y1;
    }

    public void setY1(double Y1) {
        this.Y1 = Y1;
    }

    public boolean equals(Vettore v) {
        if (v == null) {
            return false;
        }

        if (this.X0 != v.getX0()) {
            return false;
        }
        if (this.Y0 != v.getY0()) {
            return false;
        }
        if (this.X1 != v.getX1()) {
            return false;
        }
        if (this.Y1 != v.getY1()) {
            return false;
        }

        return true;
    }

    public String toString () {
        String t;

        t = "[(" + X0 + "," + Y0 + ");(" + X1 + "," + Y1 + ")]";
        return t;
    }

    public double length() {
        double l;

        l = Math.sqrt((this.X1-this.X0)*(this.X1-this.X0) + (this.Y1-this.Y0)*(this.Y1-this.Y0));
        return l;
    }
    
     private int ccw(double x0, double y0, double x1, double y1, double x2, double y2) {
        double dx1, dx2, dy1, dy2;

        dx1 = x1 - x0;
        dy1 = y1 - y0;
        dx2 = x2 - x0;
        dy2 = y2 - y0;

        if (dx1*dy2 > dy1*dx2)
            return +1;
        if (dx1*dy2 < dy1*dx2)
            return -1;
        if ((dx1*dx2 < 0) || (dy1*dy2 < 0))
            return -1;
        if ((dx1*dx1+dy1*dy1) < (dx2*dx2+dy2*dy2))
            return +1;
        return 0;
    }

    public boolean interseca(Vettore v) {
        int t1, t2;
        t1 = ((ccw(this.X0, this.Y0, this.X1, this.Y1, v.getX0(), v.getY0())*ccw(this.X0,this.Y0,this.X1,this.Y1,v.getX1(),v.getY1())));
        t2 = ((ccw(v.getX0(), v.getY0(), v.getX1(), v.getY1(), this.X0, this.Y0)*ccw(v.getX0(), v.getY0(), v.getX1(), v.getY1(), this.X1, this.Y1)));
        if ((t1 <=0) && (t2 <= 0))
            return true;
        else
            return false;
    }




    public static void main(String[] args) {
        Vettore v1, v2, v3;

        v1 = new Vettore(0,0,1,1);
        System.out.println(v1);
        System.out.println(v1.length());

        v2 = new Vettore(0,1,1,0);
        System.out.println(v2);
        System.out.println(v2.length());

        v3 = new Vettore(v1);
        System.out.println(v3);
        System.out.println(v3.length());
        
        if (v1.equals(v2))
            System.out.println("Il vettore v1 ed il vettore v2 sono uguali");
        if (v2.equals(v3))
            System.out.println("Il vettore v2 ed il vettore v3 sono uguali");
        if (v1.equals(v3))
            System.out.println("Il vettore v1 ed il vettore v3 sono uguali");

    }
}